//=============================================================================
// 添付ファイル行追加　処理関数
//   【 入力 】fileObj: 添付ファイルオブジェクト
//             tableId: 追加対象のテーブルのID属性
//             pVal   : 添付ファイル削除関数"deleteAttachFile"の第二引数としてセットする値
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】添付ファイル行の追加を行います。
//=============================================================================
function createAttachFileRecord(fileObj, tableId, pVal) {

    // 行の追加 処理開始
    var table = document.getElementById(tableId);
    var tbody = getFirstChild(table);
    var tr    = getLastChild(tbody);
    var tbody = getParentNode(tr);

    // エレメントの生成(TR)
    var newTr = document.createElement("tr");
    newTr.setAttribute("id", fileObj.systemFileName);

    // エレメントの生成(TD:ファイル名)
    var tdFileName = document.createElement("td");
    var divFileName = document.createElement("div");
    tdFileName.appendChild(divFileName);
    var html = "<input type=\"hidden\" value=\"" + escapeHTML(fileObj.systemFileName) + "\">";
    html += "<a href=\"javascript: void(0);\" onclick=\"var _p1=getPreviousElement(this); downloadTempFile(document.procForm.imwTempDirKey.value, _p1.value); return false;\">";
    html += escapeHTML(fileObj.realFileName, false);
    html += "</a>";
    divFileName.innerHTML = html;

    // エレメントの生成(TD:ファイルサイズ)
    var tdFileSize = document.createElement("td");
    tdFileSize.setAttribute("align", "right");
    tdFileSize.innerHTML = addComma(fileObj.fileSize)+" KB";

    // エレメントの生成(TD:登録者)
    var tdCreateUser = document.createElement("td");
    tdCreateUser.innerHTML = "";
    
    // エレメントの生成(TD:登録日時)
    var tdCreateDate = document.createElement("td");
    tdCreateDate.setAttribute("align", "right");
    tdCreateDate.innerHTML = "";

    // エレメントの生成(TD:削除)
    var tdDelete = document.createElement("td");
    tdDelete.setAttribute("align", "center");
    var divDeleteLink = document.createElement("div");
    tdDelete.appendChild(divDeleteLink);
    var html = "<input type=\"hidden\" value=\"" + escapeHTML(fileObj.systemFileName) + "\">";
    html += "<input type=\"hidden\" value=\"" + escapeHTML(pVal) + "\">";
    html += "<a href=\"javascript: void(0);\" onclick=\"var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1); deleteAttachFile(_p2.value, _p1.value); return false;\">";
    html += "<img class=\"link_icon\" src=\"images/icons/16x16/deletecell.png\" align=\"absmiddle\">";
    html += "</a>";
    divDeleteLink.innerHTML = html;

    // TRの子エレメントとして追加
    newTr.appendChild(tdFileName);
    newTr.appendChild(tdFileSize);
    newTr.appendChild(tdCreateUser);
    newTr.appendChild(tdCreateDate);
    newTr.appendChild(tdDelete);

    // 行を挿入
    tbody.appendChild(newTr);

    // 一覧のイベントを再設定
    setListTableEvent();
}


//=============================================================================
// 添付ファイル行削除　処理関数
//   【 入力 】systemFileName: システムファイル名(＝対象TRのID属性)
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】添付ファイル行の削除を行います。
//=============================================================================
function deleteAttachFileRecord(systemFileName) {

    // 行を削除
    var tr    = document.getElementById(systemFileName);
    var tbody = getParentNode(tr);
    tbody.removeChild(tr);

    // 一覧のイベントを再設定
    setListTableEvent();
}

//=============================================================================
// 画面表示　切り替え関数
//   【 入力 】elmId : HTMLエレメントのID属性
//             value : ""/"none" (style.display属性に設定する値)
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】指定されたHTMLエレメントのstyle.display属性を任意の値に変更します。
//=============================================================================
function setStyleDisplay(elmId, value) {
    if(document.getElementById(elmId)) {
        document.getElementById(elmId).style.display = value;
    }
}

//=============================================================================
// プルダウン　アイテム追加関数
//   【 入力 】selectElm : SELECTエレメント
//             text      : Optionオブジェクトのtextプロパティ
//             value     : Optionオブジェクトのvalueプロパティ
//             text      : OptionオブジェクトのdefaultSelectedプロパティ(省略可能)
//             text      : Optionオブジェクトのselectedプロパティ(省略可能)
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】
//=============================================================================
function addOption(selectElm, text, value, defaultSelected, selected) {
    var idx  = selectElm.length;
    selectElm.options[idx] = new Option(text, value, defaultSelected, selected);
}

//=============================================================================
// プルダウン　アイテム全削除関数
//   【 入力 】selectElm : SELECTエレメント
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】
//=============================================================================
function deleteOption(selectElm) {
    selectElm.length = 0;
}

//=============================================================================
// 複数選択セレクトボックス　選択済アイテム削除関数
//   【 入力 】selectElm : SELECTエレメント
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】
//=============================================================================
function deleteSelectedOption(selectElm) {
    for(var cnt=selectElm.options.length; cnt>0; cnt--) {
        if(selectElm.options[cnt-1].selected) {
            selectElm.remove(cnt-1);
        }
    }
}

//=============================================================================
// 複数選択セレクトボックス　アイテム取得関数
//   【 入力 】selectElm : SELECTエレメント
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】格納されているアイテムのvalue値を配列形式で返却します。
//=============================================================================
function getSelectValueMultiple(selectElm) {
    var selectValueMultiple = new Array();
    for(var cnt=0; cnt<selectElm.options.length; cnt++) {
        selectValueMultiple.push(selectElm.options[cnt].value);
    }
    return selectValueMultiple;
}

//=============================================================================
// 複数選択セレクトボックス　値包含判定関数
//   【 入力 】selectElm   : SELECTエレメント
//             targetValue : 追加するアイテムの値
//   【 返却 】true:含まれる / false:含まれない
//   【作成者】NTT DATA INTRAMART
//   【 概要 】
//=============================================================================
function containSelectValue(selectElm, targetValue) {
    for(var cnt=0; cnt<selectElm.options.length; cnt++) {
        if(selectElm.options[cnt].value == targetValue) {
            return true;
        }
    }
    return false;
}

//=============================================================================
// フロー設定チェック　処理関数
//   【 入力 】messageList  : エラーメッセージ配列
//             paramObj     : 処理用パラメータオブジェクト
//             errorMessage : エラーメッセージ
//   【 返却 】なし(エラー発生時にmessageListにerrorMessageを格納します)
//   【作成者】NTT DATA INTRAMART
//   【 概要 】画面情報の入力チェック(フロー設定)を実施します。
//=============================================================================
function checkFlowSetting(messageList, paramObj, dispObj, errorMessage) {

    // 汎用変数宣言
    var targetNodeId;
    var setNodeCount;
    var cnt1;
    var cnt2;

    for (cnt1=0; cnt1<dispObj.dispFlowSettingInfo.length; cnt1++) {
        // 設定対象のノード数分繰り返し
        targetNode = dispObj.dispFlowSettingInfo[cnt1];

        if ( (targetNode.nodeType==defineObj.nodeTyp_Horizontal
                || targetNode.nodeType==defineObj.nodeTyp_Vertical)
                && targetNode.min>0 ) {
            // 横配置ノードまたは縦配置ノードで最小設定数が1以上の場合

            setNodeCount = 0;
            for (cnt2=0; cnt2<paramObj.HVNodeConfigModels.length; cnt2++) {
                // 設定対象の横配置、縦配置ノード数分繰り返し

                if (paramObj.HVNodeConfigModels[cnt2].nodeId == targetNode.nodeId) {
                    // 申請情報から、対象ノードのノード展開数を取得
                    if (paramObj.HVNodeConfigModels[cnt2].setFlag) {
                        setNodeCount++;
                    }
                    break;
                }
            }
            if (setNodeCount===undefined || setNodeCount==0) {
                // 最小設定数が1以上のノードに対して展開設定を行っていないため、必須入力エラー
                messageList.push(errorMessage);
                return;
            }
        }
    }

    // 動的承認・確認ノードの設定チェック
    for (cnt1=0; cnt1<paramObj.DCNodeConfigModels.length; cnt1++) {
        if (!paramObj.DCNodeConfigModels[cnt1].setFlag) {
            messageList.push(errorMessage);
            return;
        }
    }

    return;
}

//=============================================================================
// ルート選択チェック　処理関数
//   【 入力 】messageList  : エラーメッセージ配列
//             paramObj     : 処理用パラメータオブジェクト
//             errorMessage : エラーメッセージ
//   【 返却 】なし(エラー発生時にmessageListにerrorMessageを格納します)
//   【作成者】NTT DATA INTRAMART
//   【 概要 】画面情報の入力チェック(ルート選択)を実施します。
//=============================================================================
function checkRoute(messageList, paramObj, errorMessage) {
    
    for(var cnt=0; cnt<paramObj.branchSelectModels.length; cnt++) {
        if(paramObj.branchSelectModels[cnt].forwardNodeIds.length == 0) {
            // ルートが選択されていない：必須入力エラー
            messageList.push(errorMessage);
            break;
        }
    }
    return;
}

//=============================================================================
// ルート選択/フロー設定複合チェック　処理関数
//   【 入力 】messageList  : エラーメッセージ配列
//             paramObj     : 処理用パラメータオブジェクト
//             errorMessage : エラーメッセージ
//   【 返却 】なし(エラー発生時にmessageListにerrorMessageを格納します)
//   【作成者】NTT DATA INTRAMART
//   【 概要 】画面情報の入力チェック(ルート選択・フロー設定)を実施します。
//=============================================================================
function checkFlowRouteSetting(messageList, paramObj, errorMessage) {

    var branchCnt;
    var fwdCnt;
    var innerCnt;

    var forwardParentNodeIds;
    var forwardNodeId;
    for(branchCnt=0; branchCnt<paramObj.branchSelectModels.length; branchCnt++) {
        // 分岐開始ノード数分繰り返し
        forwardParentNodeIds = paramObj.branchSelectModels[branchCnt].forwardParentNodeIds;

        for(fwdCnt=0; fwdCnt<forwardParentNodeIds.length; fwdCnt++) {
            // 分岐先ノード数分繰り返し

            forwardNodeId = forwardParentNodeIds[fwdCnt];

            // 動的・確認ノードに設定があるかチェック
            for(innerCnt=0; innerCnt<paramObj.DCNodeConfigModels.length; innerCnt++) {
                if(paramObj.DCNodeConfigModels[innerCnt].nodeId == forwardNodeId
                        && paramObj.DCNodeConfigModels[innerCnt].processTargetConfigs.length == 0) {
                    // ルート選択しているノードに処理対象者の設定がない：エラー
                    messageList.push(errorMessage);
                    return;
                }
            }

            // 横配置・縦配置ノードに設定があるかチェック
            for(innerCnt=0; innerCnt<paramObj.HVNodeConfigModels.length; innerCnt++) {
                if(paramObj.HVNodeConfigModels[innerCnt].nodeId == forwardNodeId) {
                    if(!paramObj.HVNodeConfigModels[innerCnt].matterNodeExpansions ||
                            paramObj.HVNodeConfigModels[innerCnt].matterNodeExpansions.length == 0 ||
                            !paramObj.HVNodeConfigModels[innerCnt].matterNodeExpansions[0].processTargetConfigModel ||
                            paramObj.HVNodeConfigModels[innerCnt].matterNodeExpansions[0].processTargetConfigModel.length == 0) {
                        // ルート選択しているノードに展開の設定がない：エラー
                        messageList.push(errorMessage);
                        return;
                    }
                }
            }
        }
    }

    return;
}

//=============================================================================
// 配列データ内要素　削除関数
//   【 入力 】aryTarget : 配列データ
//             index     : 削除する配列内のインデックス
//   【 返却 】データを削除された新しい配列データ 
//   【作成者】NTT DATA INTRAMART
//   【 概要 】指定の配列データの指定の位置のデータを削除します。
//             削除されたデータ以降のデータは、要素番号が１つずつ詰められます。
//             このメソッドは、元のデータに影響を与えません。
//=============================================================================
function removeArrayIndex(aryTarget, index) {
    var preAry  = aryTarget.slice(0, index);
    var postAry = aryTarget.slice(index+1);
    return preAry.concat(postAry);
}

//=============================================================================
// ファイルダウンロード　関数
//   【 入力 】systemMatterId   : システム案件ID
//             systemFileName   : システムファイル名
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】ファイルダウンロードダイアログを表示します。
//=============================================================================
function downloadTranFile(systemMatterId, systemFileName) {
    var targetWindow = document.getElementById("fileDownloadIframe").contentWindow;
    targetWindow.downloadTranFile(systemMatterId, systemFileName);
}

//=============================================================================
// 一時ファイルダウンロード　関数
//   【 入力 】tempDirKey       : 一時保存キー
//             systemFileName   : システムファイル名
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】ファイルダウンロードダイアログを表示します。
//=============================================================================
function downloadTempFile(tempDirKey, systemFileName) {
    var targetWindow = document.getElementById("fileDownloadIframe").contentWindow;
    targetWindow.downloadTempFile(tempDirKey, systemFileName);
}

//=============================================================================
// 処理者　変更関数
//   【 入力 】initFlag: 初期表示フラグ
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】選択された処理者によって、担当組織コンボの内容を切り替えます。
//=============================================================================
function changeAuthUser(initFlag) {

    var authUserCode = document.procForm.authUserCode.value;
    var authOrgzElm  = document.getElementById("orgn_select");

    // コンボを空に更新
    deleteOption(authOrgzElm);

    // ブランクが選択された場合
    if (isBlank(authUserCode)) {
        return;
    }

    // ブランク以外が選択された場合
    var dispAuthOrgzInfos = displayInfoObj.dispAuthOrgzInfos[authUserCode];

    // ブランク表示
    addOption(authOrgzElm, "", "");

    var selected;
    if (dispAuthOrgzInfos) {
        for (var cnt = 0; cnt < dispAuthOrgzInfos.length; cnt++) {
            // 担当組織の選択済みを決定
            // 1.初期表示(ノード設定画面からの遷移時含む)で担当組織が決定済みの場合
            // 2.初期表示(ノード設定画面からの遷移時含まず)かつ担当組織未決で選択肢がひとつの場合
            // 3.担当者切り替え時かつ選択肢がひとつの場合
            selected = (initFlag && (
                    (procParamObj.authOrgz == dispAuthOrgzInfos[cnt].comboKey) ||
                    (procParamObj.applyAuthOrgz == dispAuthOrgzInfos[cnt].comboKey) ||
                    (isBlank(procParamObj.authOrgz) && isBlank(procParamObj.applyAuthOrgz) &&
                    reqParamObj.imwCallType != "1" &&
                    dispAuthOrgzInfos.length == 1)) ||
                    (!initFlag && dispAuthOrgzInfos.length == 1));
            // 担当組織を画面に表示
            addOption(authOrgzElm, dispAuthOrgzInfos[cnt].orgzName,
                    dispAuthOrgzInfos[cnt].comboKey, null, selected);
        }
    }
}

//=============================================================================
// クライアントメッセージアンエスケープ関数
//   【 入力 】sVal: クライアントメッセージ
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】クライアントメッセージ文字列をアンエスケープします. 対象文字列が偽 (undefined, null 等) の
//            場合は変換せずにそのまま返します. 対象が数値の場合は文字列に変換します.
//=============================================================================
function unescapeClientMessage(sVal) {
    if (!sVal) {
        return sVal;
    }
    sVal = sVal + "";
    sVal = sVal.replace(/&#39;/g, "'");
    sVal = sVal.replace(/&gt;/g, ">");
    sVal = sVal.replace(/&lt;/g, "<");
    sVal = sVal.replace(/&quot;/g, "\"");
    sVal = sVal.replace(/&amp;/g, "&");
    return sVal;
}

//=============================================================================
// style:visibility設定関数
//   【 入力 】id : HTMLエレメントID
//             value : style:visibilityに設定する値
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】指定されたHTMLエレメントのstyle:visibility属性を設定します。
//=============================================================================
function setVisibility(id, value) {
    document.getElementById(id).style.visibility = value;
}

//=============================================================================
// ファイルアップロード中DIV生成関数
//   【 入力 】なし
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】ファイルアップロード中に表示するDIVを生成します。
//=============================================================================
function initFileFrame(frameId) {
    var frame = document.getElementById(frameId);
    if (!frame) return;
    var div = document.createElement("DIV");
    div.style.backgroundColor = "white";
    div.style.display = "none";
    div.innerHTML = "<h4>Please wait....</h4>";
    getParentNode(frame).insertBefore(div, frame);
    frame.forward_loading = div;
}

//=============================================================================
// ファイルアップロード中DIV表示関数
//   【 入力 】なし
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】ファイルアップロード中DIVを表示します。
//=============================================================================
function showUploading(frameId) {
    var frame = document.getElementById(frameId);
    if (!frame) return;
    var div = frame.forward_loading;
    var w = frame.offsetWidth, h = frame.offsetHeight;
    if (!document.all) h -= 17;
    div.style.width = w + "px";
    div.style.height = h + "px";
    frame.style.display = "none";
    div.style.display = "";
}

//=============================================================================
// ファイルアップロード後表示判定関数
//   【 入力 】なし
//   【 返却 】なし
//   【作成者】NTT DATA INTRAMART
//   【 概要 】ファイルアップロードが成功したか判定します。
//=============================================================================
function checkFileFrame(frameId, errorForm) {
    var frame = document.getElementById(frameId);
    if (!frame) return;
    if (typeof(frame.contentWindow.isSucceed) != "undefined" &&
            frame.contentWindow.isSucceed) {
        if (frame.forward_loading) {
            frame.style.display = "";
            frame.forward_loading.style.display = "none";
        }
        // 処理実行中フラグをOFF
        if (executingFlag) {
            executingFlag = false;
        }
        return;
    }

    // セッションタイムアウトチェック
    try {
        jsActionFile.checkSessionTimeout();
    } catch (ex) {
        showExceptionMsg(ex);
        // 処理実行中フラグをOFF
        if (executingFlag) {
            executingFlag = false;
        }
        return;
    }

    // NG
    errorForm.submit();
}
